'use strict';

define([
	'app',
	], function(app) {

	app.controller('accountFilterGroupSelection',
		["$uibModalInstance", "$uibModal", "$scope", "filters", "details", "SweetAlert",
			function($uibModalInstance, $uibModal, $scope, filters, details, SweetAlert) {

		$scope.filters = [];
		$scope.allFilters = filters;

		$scope.newFilter = function () {

			var modalInstance = $uibModal.open({
				animation: true,
				size: "lg",
				ariaLabelledBy: 'modal-title',
				ariaDescribedBy: 'modal-body',
				//templateUrl: 'templates/jetbackup/app/views/accountFilterGroupManagePopup.ptt',
				//controller: 'accountFilterGroupManagePopup'
				templateUrl: 'templates/jetbackup/app/views/accountFilterManagePopup.ptt',
				controller: 'accountFilterManagePopup'
			});

			modalInstance.result.then(function(filterDetails) {

				if(!filterDetails._id)
				{
					SweetAlert.error($scope.LANG.t("Failed!"), $scope.LANG.t("Failed to create filter"));
					return;
				}

				$scope.allFilters[filterDetails._id] = filterDetails;
				$scope.selectedFilter = filterDetails._id;
				$scope.ok();
				/*
				//$scope.allFilters[filterDetails._id] = filterDetails;
				$scope.allFilters[filterDetails._id] = filterDetails;
				$scope.setFilters();
				*/

			}, function () {
				//$log.info('Modal dismissed at: ' + new Date());
			});

		};

		$scope.setFilters = function () {
			for(var i in $scope.allFilters) {
				$scope.filters.push($scope.allFilters[i]);
			}
		};

		$scope.setFilters();

		$scope.selectedFilter = $scope.filters.length ? $scope.filters[0]._id : '';

		$scope.ok = function () {
			$uibModalInstance.close( $scope.selectedFilter );
		};

		$scope.cancel = function () {
			$uibModalInstance.dismiss($scope.LANG.t('cancel'));
		};
	}]);

});