'use strict';

define([
	'app',
	], function(app) {

	app.controller('cloneJobsSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "jobs",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, jobs) {

				$scope.loading = false;
				$scope.jobs = [];

				$scope.fetchJobs = function () {

					$scope.loading = true;

					jetapi.listCloneJobs({ sort: { name: 1 } }, function (response) {

						for (var i = 0; i < response.data.jobs.length; i++) {
							response.data.jobs[i].checked = jobs !== undefined && jobs.length ? jobs.indexOf(response.data.jobs[i]._id) >= 0 : false;
						}

						$scope.jobs = response.data.jobs;
						$scope.loading = false;

					});
				};

				$timeout($scope.fetchJobs());

				$scope.ok = function () {

					var selected = [];
					for (var i = 0; i < $scope.jobs.length; i++) {
						if($scope.jobs[i].checked) selected.push($scope.jobs[i]._id);
					}
					$uibModalInstance.close( selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});