'use strict';

define([
	'app',
	], function(app) {
	app.controller("destinationDropbox", ["$scope", "SweetAlert",
		function ($scope, SweetAlert) {

		$scope.openAuthentication = function(appKey, secretKey) {

			if(!appKey)
			{
				SweetAlert.swal($scope.LANG.t("Configuration Issue"), $scope.LANG.t('Please add the App Key first'), "error");
				return false;
			}

			if(!secretKey)
			{
				SweetAlert.swal($scope.LANG.t("Configuration Issue"), $scope.LANG.t('Please add the Secret Key first'), "error");
				return false;
			}

			var left = screen.width / 2 - 225;
			var top = screen.height / 2 - 250;

			window.open("https://dropbox.com/oauth2/authorize?response_type=code&token_access_type=offline&redirect_uri=https://auth.jetbackup.com/dropbox/&client_id=" + appKey, '', 'height=500,width=650,left=' + left + ',top=' + top + ',toolbar=no,titlebar=no,status=no,scrollbars=no,resizable=yes,menubar=no');

			return false;
		};
	}]);
});