'use strict';

define([
	'app',
	], function(app) {
	app.controller("destinationGoogleDrive", ["$scope", "SweetAlert", function ($scope, SweetAlert) {

		$scope.openAuthentication = function(privateKey) {

			if(!privateKey)
			{
				SweetAlert.swal($scope.LANG.t("Configuration Issue"), $scope.LANG.t('Please add the private key first'), "error");
				return false;
			}

			try {
				privateKey = eval('(' + privateKey + ')');
			} catch (e) {
				SweetAlert.swal($scope.LANG.t("Configuration Issue"), $scope.LANG.t('Invalid private key provided'), "error");
				return false;
			}

			if(privateKey.web === undefined || privateKey.web.client_id === undefined)
			{
				SweetAlert.swal($scope.LANG.t("Configuration Issue"), $scope.LANG.t('Unable to find client id in the private key you provided'), "error");
				return false;
			}

			var iframeURLArgs = {
				response_type: 'code',
				access_type: 'offline',
				client_id: privateKey.web.client_id,
				redirect_uri: 'https://auth.jetbackup.com/google/',
				state: 'state_parameter_passthrough_value',
				scope: 'https://www.googleapis.com/auth/drive https://www.googleapis.com/auth/userinfo.email', // you can add more scopes by separating by space
				approval_prompt: 'auto'
			};

			var iframeURL = 'https://accounts.google.com/o/oauth2/auth?';

			angular.forEach(iframeURLArgs, function(value, key) {
				iframeURL += key + '=' + encodeURIComponent(value) + '&';
			});

			var left = screen.width / 2 - 225;
			var top = screen.height / 2 - 200;

			window.open(iframeURL, '', 'height=600,width=450,left=' + left + ',top=' + top + ',toolbar=no,titlebar=no,status=no,scrollbars=no,resizable=yes,menubar=no');

			return false;
		};
	}]);
});