'use strict';

define([
	'app',
	], function(app) {

	app.controller('packagesSelection',
		["$uibModalInstance", "$uibModal", "$scope", "$timeout", "jetapi", "meta", "packages",
			function($uibModalInstance, $uibModal, $scope, $timeout, jetapi, meta, packages) {

				$scope.loading = false;
				$scope.packages = [];

				$scope.fetchPackages = function () {

					$scope.loading = true;

					jetapi.listPackages({}, function (response) {

						for (var i = 0; i < response.data.packages.length; i++) {
							response.data.packages[i].checked = packages !== undefined && packages.length ? packages.indexOf(response.data.packages[i].name) >= 0 : false;
						}

						$scope.packages = response.data.packages;
						$scope.loading = false;

					});
				};

				$timeout($scope.fetchPackages());

				$scope.ok = function () {

					var selected = [];
					for (var i = 0; i < $scope.packages.length; i++) {
						if($scope.packages[i].checked) selected.push($scope.packages[i].name);
					}
					$uibModalInstance.close( selected );
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss($scope.LANG.t('cancel'));
				};
			}
		]
	);
});