'use strict';

define([
	'app',
	], function(app) {

	app.controller('scheduleManagePopup',
		["$uibModalInstance", "$uibModal", "$routeParams", "$rootScope", "$scope", "SweetAlert", "jetapi", "schedule", "type",  "excludeids",
			function($uibModalInstance, $uibModal, $routeParams, $rootScope, $scope, SweetAlert, jetapi, schedule, type, excludeids) {

				$scope.status = undefined;
				$scope.type = type;
				$scope.excludeids = excludeids;
				$scope.schedule = schedule;

				/*
				$scope.saveData = {
					name: '',
					type: 1,
					typedata: '',
					time: '01:00 AM',
					delaytype: 'minutes',
					delayamount: 0
				};
				*/

				$routeParams.id = null;
				$scope.retain = 0;

				if($scope.schedule) {
					$routeParams.id = $scope.schedule._id;
					$scope.retain = $scope.schedule.retain;
				}

				$scope.$on('scheduleResponse', function (event, response) {

					if(response.success)
					{
						jetapi.getSchedule({ _id: response.data._id }, function(details) {

							if(details.success)
							{
								SweetAlert.success($scope.LANG.t("Success!"), response.message);
								details.data.retain = parseInt($scope.retain);
								$uibModalInstance.close(details.data);
								return;
							}

							$scope.status = {
								message: details.message,
								type: "danger",
								closeable: false,
								ttl: 10000
							};
						});
						return;
					}

					$scope.status = {
						message: response.message,
						type: "danger",
						closeable: false,
						ttl: 10000
					};
				});

				$scope.ok = function () {
					if($scope.retain) $scope.retain = parseInt($scope.retain);
					if($scope.type < 512 && ($scope.retain <= 0 || isNaN($scope.retain)) ) {
						$scope.status = {
							message: $scope.LANG.t("Invalid backups retain selected"),
							type: "danger",
							closeable: false,
							ttl: 10000
						};
						return;
					}
					$rootScope.$broadcast('createSchedule');
				};

				$scope.cancel = function () {
					$uibModalInstance.dismiss();
				};
	}]);

});