'use strict';

define([
	'app',
	], function(app) {
	app.controller('scheduleSelection',
		["$uibModalInstance", "$uibModal", "$scope", "schedules", "schedule", "details", "type",
			function($uibModalInstance, $uibModal, $scope, schedules, schedule, details, type) {

		$scope.type = type;
		$scope.schedule = schedule;
		$scope.schedules = [];
		$scope.allSchedules = schedules;

		$scope.newSchedule = function () {

			var modalInstance = $uibModal.open({
				animation: true,
				size: "lg",
				ariaLabelledBy: 'modal-title',
				ariaDescribedBy: 'modal-body',
				templateUrl: 'templates/jetbackup/app/views/scheduleManagePopup.ptt',
				controller: 'scheduleManagePopup'
			});

			modalInstance.result.then(function(scheduleDetails) {

				if(!scheduleDetails._id)
				{
					SweetAlert.error($scope.LANG.t("Failed!"), $scope.LANG.t("Failed to create schedule"));
					return;
				}

				$scope.allSchedules[scheduleDetails._id] = scheduleDetails;
				$scope.getUsableSchedules();
				$scope.scheduleDetails._id = scheduleDetails._id;
			}, function () {
				//$log.info('Modal dismissed at: ' + new Date());
			});

		};

		$scope.getUsableSchedules = function() {

			$scope.schedules = [];
			$scope.schedulesTypesInUse = [];

			for(var i = 0; i < details.schedules.length; i++) {
				if(schedules[details.schedules[i]._id] === undefined) continue;
				$scope.schedulesTypesInUse.push(schedules[details.schedules[i]._id].type);
			}

			for(var i in $scope.allSchedules)
			{
				if((schedule === undefined || $scope.allSchedules[schedule._id].type !== $scope.allSchedules[i].type) && $scope.schedulesTypesInUse.indexOf($scope.allSchedules[i].type) >= 0) continue;

				var add = true;

				for(var a = 0; a < details.schedules.length; a++)
				{
					if(
						(i === details.schedules[a]._id &&
							(schedule === undefined || schedule._id !== i))
					)
					{
						add = false;
						break;
					}
				}

				if(add) {
					$scope.allSchedules[i].label = $scope.allSchedules[i].name + ' (' + $scope.allSchedules[i].type_name + ')';
					$scope.schedules.push($scope.allSchedules[i]);
				}
			}
		};

		$scope.getUsableSchedules();

		if(schedule !== undefined)
		{
			$scope.scheduleDetails = {
				_id: schedule._id,
				retain: schedule.retain
			};
		}
		else
		{
			$scope.scheduleDetails = {
				_id: $scope.schedules.length ? $scope.schedules[0]._id : '',
				retain: 0
			};
		}

		$scope.ok = function () {

			if($scope.type === 'backup') $scope.scheduleDetails.retain = parseInt($scope.scheduleDetails.retain);
			$uibModalInstance.close( $scope.scheduleDetails );
		};

		$scope.cancel = function () {
			$uibModalInstance.dismiss($scope.LANG.t('cancel'));
		};
	}]);

});