'use strict';

define([
	'app',
	], function(app) {
	app.controller("generalSettings", ["$rootScope", "$scope", "jetapi", "SweetAlert",
		function ($rootScope, $scope, jetapi, SweetAlert) {

			$scope.generateMasterPrivateKey = function () {
				jetapi.generateRootEncryptionKey({}, function (response) {
					if(response.success) {
						SweetAlert.success($scope.LANG.t("Success!"), response.message);
						return;
					}

					SweetAlert.error($scope.LANG.t("Error!"), response.message);
				});
			};

			$scope.disconnectMC = function() {

				SweetAlert.swal({
					title: $scope.LANG.t("Are you sure?"),
					text: $scope.LANG.t("JetBackup will stop reporting to the MC server."),
					icon: "warning",
					buttons: [$scope.LANG.t("Cancel"), true]
				}, function(isConfirm){
					if (isConfirm) {
						jetapi.disconnectManagementConsole({},  function (response) {
							if(response.success) {
								SweetAlert.success($scope.LANG.t("Success!"), response.message);
								return;
							}
							SweetAlert.error($scope.LANG.t("Error!"), response.message);
						});
					}
				});
			};

			$scope.kill_zombie_ttl_rates = [
				{ label: $scope.LANG.t("Disabled"), value: 0 },
				{ label: 1, value: 1 },
				{ label: 2, value: 2 },
				{ label: 3, value: 3 },
				{ label: 4, value: 4 },
				{ label: 5, value: 5 },
				{ label: 6, value: 6 },
				{ label: 7, value: 7 }
			];

			$scope.delete_orphans_ttl_rates = [
				{ label: $scope.LANG.t("Unlimited"), value: 0 },
				{ label: 1, value: 1 },
				{ label: 2, value: 2 },
				{ label: 3, value: 3 },
				{ label: 5, value: 5 },
				{ label: 7, value: 7 },
				{ label: 14, value: 14 },
				{ label: 30, value: 30 }
			];

			$scope.delete_logs_ttl_rates = [
				{ label: $scope.LANG.t("Disabled"), value: 0 },
				{ label: 1, value: 1 },
				{ label: 2, value: 2 },
				{ label: 3, value: 3 },
				{ label: 5, value: 5 },
				{ label: 7, value: 7 },
				{ label: 14, value: 14 },
				{ label: 30, value: 30 }
			];

			$scope.manual_backups_ttl_rates = [
				{ label: $scope.LANG.t("Unlimited"), value: 0 },
				{ label: 1, value: 1 },
				{ label: 2, value: 2 },
				{ label: 3, value: 3 },
				{ label: 5, value: 5 },
				{ label: 7, value: 7 },
				{ label: 14, value: 14 },
				{ label: 30, value: 30 }
			];
		}
	]);
});
