'use strict';

define([
	'app',
	'libraries/consts'
	], function(app, CONSTS) {
	app.controller("restoreSettings",
		["$rootScope", "$scope", "$timeout", "jetapi",
			function ($rootScope, $scope, $timeout, jetapi) {
				$scope.ownership_types = ['nobody','user'];


				$scope.safety_days_rates = [
					{ label: $scope.LANG.t("Unlimited"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 },
					{ label: 6, value: 6 },
					{ label: 7, value: 7 },
				];

				$scope.destinations = [{_id: '', name: $scope.LANG.t('- Disable Safety Backups -') }];

				$scope.fetchDestinations = function() {
					jetapi.listDestinations({}, function(response) {
						for(var i = 0; i < response.data.destinations.length; i++) {
							if(
								response.data.destinations[i].clone_destination ||
								response.data.destinations[i].engine != CONSTS.DESTINATION_ENGINE_JETBACKUP ||
								!response.data.destinations[i].incremental_ability
							) continue;
							$scope.destinations.push(response.data.destinations[i]);
						}
					});
				};

				$timeout($scope.fetchDestinations());
			}
		]
	);
});