'use strict';

define([
	'app',
	], function(app) {
	app.controller("snapshotsSettings",
		["$rootScope", "$scope", "$routeParams", "$location", "$timeout", "jetapi",
			function ($rootScope, $scope, $routeParams, $location, $timeout, jetapi) {

				$scope.backups = [{_id: '', name: $scope.LANG.t('- Disable Snapshot System -') }];
				$scope.sizes = ['MB','GB','TB'];

				// console.log($scope.saveData);
				$scope.max_account_rates = [
					{ label: $scope.LANG.t("Unlimited"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 },
				];

				$scope.max_days_rates = [
					{ label: $scope.LANG.t("Disabled"), value: 0 },
					{ label: 1, value: 1 },
					{ label: 2, value: 2 },
					{ label: 3, value: 3 },
					{ label: 4, value: 4 },
					{ label: 5, value: 5 },
					{ label: 10, value: 10 },
					{ label: 20, value: 20 },
					{ label: 30, value: 30 },
				];

				$scope.usage_rates = [
					{ label: $scope.LANG.t("Disabled"), value: 0 }
				];

				$scope.inodes_rates = [
					{label: $scope.LANG.t("Disabled"), value: 0}
				];

				$scope.fetchBackupJobs = function() {
					var params = {find:{}};
					params.find['backup_types'] = {$lte: 127};
					jetapi.listBackupJobs(params, function(response) {
						for(var i = 0; i < response.data.jobs.length; i++) $scope.backups.push(response.data.jobs[i]);
					});
				};

				$timeout($scope.fetchBackupJobs());

	}]);
});