'use strict';

define([
	'app'
], function (app) {
	app.controller("JWizard",
		["$rootScope", "$scope", "$location", "$timeout", "$uibModalInstance", "lang", "jetapi", "meta", "SweetAlert", "wizardStorage", "JWService",
			function ($rootScope, $scope, $location, $timeout, $uibModalInstance, lang, jetapi, meta, SweetAlert, wizardStorage, JWService) {

				lang.setNS("wizards", $scope);

				$scope.init = function () {
					$scope.jobWizard = true;
					$scope.restoreWizard = true;
					$scope.wizardOptions = {
						type: 'backup' // can be 'cloneCpanel' as well
					};
					$scope.service = JWService;
					$scope.wizardName = JWService._wizardName;
					$scope.wizardData = {};
					$scope.preview = {};
					$scope.first = JWService._firstStep;
					$scope.currentStep 	= JWService.currentStep;
					$scope.wizardData = JWService.getData();
				}();

				JWService.setWatch(function() {
					$scope.wizardData = JWService.getData();
				});

				// Executing the current step process function.
				$scope.process = function (data) {
					JWService.process(data);
				};

				$scope.next = function () {
					JWService.next();
				};

				$scope.prev = function () {
					JWService.prev();
				};

				$scope.finish = function () {
					JWService.next();
				};

			}
		]
	);
});