'use strict';

define([
	'app',
	'libraries/consts',
], function (app, CONSTS) {
	app.controller("selectRestoreType",
		["$rootScope", "$scope", "$timeout", "SweetAlert", "jetapi", "$uibModal",
			function ($rootScope, $scope, $timeout, SweetAlert, jetapi, $uibModal) {

				$scope.CONSTS = CONSTS;

				if ($scope.service) {
					$scope.service.showClose = true;
					if($scope.wizardData.accounts) $scope.wizardData.accounts = [];
				}

				$scope.backupTypes = [
					{label: $scope.LANG.t("Full Backups"), 	value: CONSTS.BACKUP_TYPE_FULL},
					{label: $scope.LANG.t("File Backups"),	value: CONSTS.BACKUP_TYPE_FILES},
					{label: $scope.LANG.t("Database Backups"), value: CONSTS.BACKUP_TYPE_DATABASES},
					{label: $scope.LANG.t("Email Backups"), 	value: CONSTS.BACKUP_TYPE_EMAILS},
					{label: $scope.LANG.t("Cron Job Backups"), value: CONSTS.BACKUP_TYPE_CRON_JOBS},
					{label: $scope.LANG.t("DNS Zone Backups"), value: CONSTS.BACKUP_TYPE_DNS_ZONES}
				];

				$scope.backupStructures = [
					{label: $scope.LANG.t("Incremental"),  value: CONSTS.BACKUP_STRUCTURE_INCREMENTAL},
					{label: $scope.LANG.t("Archived"), 	value: CONSTS.BACKUP_STRUCTURE_ARCHIVED},
					{label: $scope.LANG.t("Compressed"),   value: CONSTS.BACKUP_STRUCTURE_COMPRESSED}
				];


				$scope.backupDestinations = [{_id:'', name:'All Destinations' }];


				$scope.data = {
					selectedBackupType: $scope.wizardData.type ? $scope.wizardData.type : $scope.backupTypes[0].value,
					selectedBackupStructure: $scope.wizardData.structure ? $scope.wizardData.structure : $scope.backupStructures[0].value,
					selectedBackupDestination: $scope.wizardData.destination ? $scope.wizardData.destination : $scope.backupDestinations[0]._id
				};

				jetapi.listDestinations({}, function (response) {
					if(!response.success) {
						$scope.service.wizardAlert = {
							message: response.message,
							closeable: true,
							type: "error",
							ttl: 4000
						};
					}

					for(var i=0; i<response.data.destinations.length; i++)
						if(response.data.destinations[i].type !== 'CloneCpanel')
							$scope.backupDestinations.push(response.data.destinations[i]);
				});

				$scope.validateType = function(){
					if($scope.data.selectedBackupType !== CONSTS.BACKUP_TYPE_FULL) {
						$scope.data.selectedBackupStructure = CONSTS.BACKUP_STRUCTURE_INCREMENTAL;
						return true;
					}

					return false;
				};

				$scope.$on($scope.wizardName, function (e,d) {

					var data = {
						type: $scope.data.selectedBackupType,
						destination: $scope.data.selectedBackupDestination,
						structure: $scope.data.selectedBackupStructure
					};
					$scope.process({success: true, data:data});
				});

			}
		]);
});