'use strict';

define([
	'app',
	'libraries/consts',
], function (app, CONSTS) {
	app.controller("wizardBackupJobManage",
		["$rootScope", "$scope", "$location", "$timeout", "$uibModal", "jetapi",
			function ($rootScope, $scope, $location, $timeout, $uibModal, jetapi) {


				$scope.types = [
					{ label: $scope.LANG.t("Accounts"),
						value: CONSTS.BACKUP_TYPE_FULL,
						description: $scope.LANG.t("Accounts -Back up cPanel accounts")
					},
					{ label: $scope.LANG.t("Directories"),
						value: CONSTS.BACKUP_TYPE_DIRECTORIES,
						description: $scope.LANG.t("Directories - Pick directories to back up")
					},
					{ label: $scope.LANG.t("Replicate"),
						value: CONSTS.BACKUP_TYPE_REPLICATE,
						description: $scope.LANG.t("Replicate - Copy files/folders to the destination with the exec same structure")
					}
				];

				$scope.flags = [
					{ label: $scope.LANG.t("Incremental"), value: 1, description: $scope.LANG.t("Back up cPanel accounts")},
					{ label: $scope.LANG.t("Archived"), 	value: 2, description: $scope.LANG.t("Back up cPanel accounts")},
					{ label: $scope.LANG.t("Compressed"), 	value: 4, description: $scope.LANG.t("Back up cPanel accounts")}
				];

				// $scope.account_types = [
				// 	{ label: $scope.LANG.t("cPanel Configurations"), value: CONSTS.BACKUP_TYPE_CONFIG },
				// 	{ label: $scope.LANG.t("Home dir Files"), value: CONSTS.BACKUP_TYPE_FILES },
				// 	{ label: $scope.LANG.t("Databases (Creates a full database dump)"), value: CONSTS.BACKUP_TYPE_DATABASES },
				// 	{ label: $scope.LANG.t("Emails"), value: CONSTS.BACKUP_TYPE_EMAILS },
				// 	{ label: $scope.LANG.t("Cron Jobs"), value: CONSTS.BACKUP_TYPE_CRON_JOBS },
				// 	{ label: $scope.LANG.t("DNS Zones"), value: CONSTS.BACKUP_TYPE_DNS_ZONES },
				// 	{ label: $scope.LANG.t("SSL Certificates"), value: CONSTS.BACKUP_TYPE_SSL_CERTIFICATES }
				// ];

				$scope.data = {
					backuptype: CONSTS.BACKUP_TYPE_FULL,
					selectedType: $scope.types[0],
					flag: $scope.flags[0].value,
					selectedFlag: $scope.flags[0]
				};


				$scope.toggleBackupType = function (type) {
					$scope.data.selectedType = type;
				};

				$scope.selectFlag = function (flag) {
					$scope.data.selectedFlag = flag;

				};

				$scope.flagDisabled = function(flag) {
					console.log(flag);
					if ($scope.data.selectedType === CONSTS.BACKUP_TYPE_REPLICATE)
						if(flag === 2 || flag === 4) return true;


					if(flag > 1 && $scope.data.backuptypes === 512) {
						$scope.data.flag = 1;
						return true;
					}

					// if($scope.destinationsIds[$scope.data.destination] !== undefined) {
					// 	var destType = $scope.destinationsIds[$scope.saveData.destination].type;
					//
					// 	if(flag === 1 && (destType === 'Dropbox' || destType === 'GoogleDrive' || destType === 'Backblaze')) {
					// 		if($scope.data.flag === 1) $scope.data.flag = 2;
					// 		return true;
					// 	}
					// }
					return false;
				};



			}
		]
	);
});