'use strict';
define(['app'], function (app) {
	app.directive("filterBox", ["$parse", "lang",
		function($parse, lang) {

			return {
				restrict: "EA",
				template: '<div class="filter">\n' +
				'    <div ng-hide="!boxOptions[0]" class="form-group" >\n' +
				'        <label for="{{parentID}}_select" class="title">{{filterTitle}}</label>\n' +
				'        <select id="{{parentID}}_select"\n' +
				'            class="form-control"\n' +
				'            ng-options="filterOpt.value as filterOpt.label for filterOpt in boxOptions"\n' +
				'            ng-model="filter">\n' +
				'        </select>\n' +
				'    </div>\n' +
				'</div>',
				require: "ngModel",
				replace: true,
				scope: {
					"parentID": "@id",
					"filterTitle": "@",
					"boxOptions": "=boxOptions"
				},

				link: function(scope, element, attrs, ngModel) {

					if (!ngModel) {
						return; // do nothing if no ng-model on the directive
					}

					ngModel.$render = function() {
						if(scope.filterTitle === undefined) scope.filterTitle = lang.t("Filter");
						scope.filter = ngModel.$viewValue;
					};

					scope.$watch("filter", function(newValue, oldValue) {
						if (newValue === oldValue) {
							return; // No update on same value;
						}

						ngModel.$setViewValue(scope.filter);
					});
				}
			};
		}
	]);

});