'use strict';

define([], function() {
	var CONSTS = function() { this._init(); };

	CONSTS.prototype = {
		DOCS_URL: "https://docs.jetbackup.com/v4.0/whm",

		BASE_URL: "cgi/addons/jetbackup/index.cgi",

		// Backup Types
		BACKUP_TYPE_CONFIG: 1<<0,
		BACKUP_TYPE_FILES: 1<<1,
		BACKUP_TYPE_DATABASES: 1<<2,
		BACKUP_TYPE_EMAILS: 1<<3,
		BACKUP_TYPE_CRON_JOBS: 1<<4,
		BACKUP_TYPE_DNS_ZONES: 1<<5,
		BACKUP_TYPE_SSL_CERTIFICATES: 1<<6,
		BACKUP_TYPE_FULL: 0,
		BACKUP_TYPE_DIRECTORIES_FILES: 1<<7,
		BACKUP_TYPE_DIRECTORIES_DIRS: 1<<8,
		BACKUP_TYPE_DIRECTORIES: 0,
		BACKUP_TYPE_REPLICATE: 1<<9,
		BACKUP_TYPE_DISASTER_RECOVERY: 1<<10,

		BACKUP_STRUCTURE_INCREMENTAL: 1<<0,
		BACKUP_STRUCTURE_ARCHIVED: 1<<1,
		BACKUP_STRUCTURE_COMPRESSED: 1<<2,

		DESTINATION_ENGINE_JETBACKUP: 1,
		DESTINATION_ENGINE_CPANEL: 2,

		BACKUP_CPANEL: 1,
		BACKUP_DIRECTORY: 2,
		BACKUP_DISASTER_RECOVERY: 3,

		ACCOUNT_FILTER_TYPE_ACCOUNT: 1<<1,
		ACCOUNT_FILTER_TYPE_RESELLER: 1<<2,
		ACCOUNT_FILTER_TYPE_SUSPENSION: 1<<3,
		ACCOUNT_FILTER_TYPE_DISK_USAGE: 1<<4,
		ACCOUNT_FILTER_TYPE_INODE_USAGE: 1<<5,
		ACCOUNT_FILTER_TYPE_PACKAGE: 1<<6,
		ACCOUNT_FILTER_TYPE_RANGE: 1<<7,
		ACCOUNT_FILTER_TYPE_REGEX: 1<<8,

		ACCOUNT_FILTER_CONDITION_INCLUDE: 1,
		ACCOUNT_FILTER_CONDITION_EXCLUDE: 2,

		HOOK_TYPE_POSITION_PRE: 1,
		HOOK_TYPE_POSITION_POST: 2,

		QUEUE_TYPE_RESTORE: 1,
		QUEUE_TYPE_DOWNLOAD: 2,

		QUEUE_STATUS_PENDING:1,
		QUEUE_STATUS_PROCESSING:2,
		QUEUE_STATUS_COMPLETED:100,
		QUEUE_STATUS_CANCELLED:101,
		QUEUE_STATUS_FAILED:102,

		HOOK_POSITION_BACKUP: 1,
		HOOK_POSITION_CLONE: 2,
		HOOK_POSITION_RESTORE: 3,
		HOOK_POSITION_DOWNLOAD: 4,
		HOOK_POSITION_REINDEX: 5,
		HOOK_POSITION_SNAPSHOT: 6,
		HOOK_POSITION_DAILY_CRON: 7,
		HOOK_POSITION_BACKUP_ACCOUNT: 8,
		HOOK_POSITION_CLONE_ACCOUNT: 9,

		// apply conditions to
		APPLY_CONDITION_TO_CPANEL: 1<<0,
		APPLY_CONDITION_TO_WHM: 1<<1,

		PATH_FILTER: /(^[^\/])|(((\/+|^)\.{2})+(\/+|$)|\/{2,})|([`:;\\!$&*()])/,
		PATH_FILTER_PATTERNS: /(((\/+|^)\.{2})+(\/+|$)|\/{2,})|([`:;\\!$&()])/,

		WIZARD_STORAGE: 		 	 'backupJobWizard',

		_init: function () {
			this.BACKUP_TYPE_FULL =
				this.BACKUP_TYPE_CONFIG |
				this.BACKUP_TYPE_FILES |
				this.BACKUP_TYPE_DATABASES |
				this.BACKUP_TYPE_EMAILS |
				this.BACKUP_TYPE_CRON_JOBS |
				this.BACKUP_TYPE_DNS_ZONES |
				this.BACKUP_TYPE_SSL_CERTIFICATES;

			this.BACKUP_TYPE_DIRECTORIES =
				this.BACKUP_TYPE_DIRECTORIES_FILES |
				this.BACKUP_TYPE_DIRECTORIES_DIRS;
		}
	};

	return new CONSTS();
});