'use strict';

require([
	'app',
	'libraries/permissions',
	'libraries/consts',
	'services/storage',
	'filters/html',
	'filters/capitalize',
	'filters/executionTime',
	'directives/loadingScreen',
	'directives/loadingBox',
	'directives/pageSize',
	'directives/sortBy',
	'directives/search',
	'directives/tooltip',
	'directives/filterBox',
	'directives/alertBox',
	'directives/ngLanguage',
	'directives/navigation',
	'directives/inputSelector',
	'services/jetapi',
	'services/utils',
	'services/loader',
	'services/meta',
	'services/filter',
	'services/lang',
	'services/filterManager',
	'services/JWizardService',
	'services/wizards',
	'controllers/wizard/JWizard',
	'controllers/wizard/wizardWelcomePage',
	'controllers/wizard/sshFields',
	'controllers/wizard/localFields',
	'controllers/wizard/wizardDestinationPicker',
	'controllers/wizard/wizardSchedule',
	'controllers/wizard/wizardFilters',
	'controllers/wizard/wizardBackupJobManage',
	'controllers/wizard/selectAccount',
	'controllers/wizard/selectRestoreType',
	'controllers/wizard/selectBackup',
	'controllers/wizard/wizardFileManager',
	'controllers/sideMenu',
	'controllers/security',
	'controllers/showcase',
	'controllers/permissions',
	'controllers/settings',
	'controllers/settings/generalSettings',
	'controllers/settings/gdprSettings',
	'controllers/settings/restoreSettings',
	'controllers/settings/snapshotsSettings',
	'controllers/settings/performanceSettings',
	'controllers/settings/resourceSettings',
	'controllers/settings/notificationSettings',
	'controllers/dashboard',
	'controllers/accounts',
	'controllers/accountManage',
	'controllers/backupSelect',
	'controllers/backupManager',
	'controllers/backupManagerAccounts',
	'controllers/backupManagerDirectories',
	'controllers/hookManage',
	'controllers/hooks',
	'controllers/jobManage',
	'controllers/backupJobManage',
	'controllers/backupJobs',
	'controllers/cloneJobManage',
	'controllers/cloneJobs',
	'controllers/restoreConditionManage',
	'controllers/restoreConditions',
	'controllers/queuePriorityManage',
	'controllers/queuePriorities',
	'controllers/filePermissionManage',
	'controllers/filePermissions',
	'controllers/alerts',
	'controllers/agreement',
	'controllers/logs',
	'controllers/logViewer',
	'controllers/gdprMustAgree',
	'controllers/queues',
	'controllers/fileManager',
	'controllers/scheduleManagePopup',
	'controllers/scheduleManage',
	'controllers/schedulesList',
	'controllers/schedules',
	'controllers/accountFilters',
	'controllers/accountFilterManage',
	'controllers/accountFilterManagePopup',
	//'controllers/accountFilterGroups',
	//'controllers/accountFilterGroupManage',
	//'controllers/accountFilterGroupManagePopup',
	'controllers/snapshotLockSelection',
	'controllers/destinationManage',
	'controllers/destinations/AmazonS3',
	'controllers/destinations/GoogleDrive',
	'controllers/destinations/Dropbox',
	'controllers/destinations/Local',
	'controllers/destinations',
	'controllers/disasterRecovery',
	'controllers/disasterRecoverySelection',
	'controllers/disasterRecoveryDestination',
	'controllers/disasterRecoveryRestoreDR',
	'controllers/disasterRecoveryAccounts',
	'controllers/error',
	'controllers/404',
	'controllers/plugin',

	// selections
	'controllers/backupJobsSelection',
	'controllers/cloneJobsSelection',
	'controllers/destinationsSelection',
	'controllers/cloneSelection',
	'controllers/accountsSelection',
	'controllers/resellersSelection',
	'controllers/packagesSelection',
	'controllers/accountFilterGroupSelection',
	'controllers/scheduleSelection',

	// TODO remove once we fix the cmb
	'showcase/100_rootPrivateKey/controller',
	'showcase/101_multiProcessingSetting/controller',

	// security plugins
	'plugins/security/cxs/controller',
	'plugins/security/imunify360/controller'
], function () {
	angular.bootstrap(document, ['JetBackupApp']);
});