'use strict';

define(['app'], function (app) {
	app.factory('filter', [function () {

		var filter = function(storage_id) { this._init(storage_id); };

		filter.prototype = {
			_storage_key: undefined,
			_data: {},
			_initStorage: function (storage_id) {
				this._storage_key = "sort_" + storage_id;
				var sort = localStorage.getItem(this._storage_key);
				if(sort === undefined) {
					localStorage.setItem(this._storage_key, JSON.stringify(this._data));
				} else {
					var data = JSON.parse(sort);
					if(data) this._data = data;
				}
			},
			_init: function (storage_id) {
				var defaults = { filter: '' };

				this._data = {};
				for(var i in defaults) this._data[i] = defaults[i];
				if(storage_id !== undefined) this._initStorage(storage_id);
			},
			set: function (key, value) {
				this._data[key] = value;
				localStorage.setItem(this._storage_key, JSON.stringify(this._data));
			},
			get: function (key, defaultValue) { return this._data[key] !== undefined ? this._data[key] : defaultValue; },
			setFilter: function (filter) { this.set('filter', filter); },
			getFilter: function () { return this.get('filter'); },
			setData: function (data) { this._data = data; },
			getData: function () { return this._data; }
		};

		return { new: function (storage_id) { return new filter(storage_id); } };
	}]);
});