'use strict';

define([
		'app'
	], function (app) {
		app.controller('backups',
			['$scope', 'meta', 'lang', '$interval',
				function ($scope, meta, lang, $interval) {


					$scope.clear = function() {
						$scope.meta.filterValue = '';
						$scope.fetchData();
					};

					$scope.minimizeAll = function () {
						$scope.actionModule = '';
						for(var i=0; i< $scope.backups.length; i++) $scope.backups[i].isExpanded = false;
					};

					$scope.cleatStatus = function() {
						for(var i=0; i< $scope.backups.length; i++)	$scope.backups[i].status = null;
					};

					$scope.openNotesEdit = function(backup) {
						backup.editing = true;
						$scope.lastNote = backup.notes;
					};

					$scope.saveNotes = function (backup) {$scope.backupHandler.saveNote(backup)};

					$scope.onClickRestore = function(backup) {
						$scope.minimizeAll();
						backup.isExpanded = true;
						$scope.actionModule = 'restore';
					};

					$scope.onClickDownload = function(backup) {
						$scope.minimizeAll();

						if($scope.downloading) {
							backup .status = {
								message: lang.t("Can't download while other download is in progress"),
								type: 'danger',
								closeable: true,
								ttl: 5000
							};
							return;
						}
						backup.isExpanded = true;
						$scope.actionModule = 'download';
					};

					$scope.onClickDeleteDownload = function(backup) {
						$scope.minimizeAll();
						backup.isExpanded = true;
						$scope.actionModule = 'deletedownload';
					};


					$scope.isConditionsAgreed = function() {
						for(var i in $scope.config.restore_conditions) {
							if($scope.config.restore_conditions[i].type !== 0 && $scope.config.restore_conditions[i].type !== $scope.backupType) continue;
							if(!$scope.config.restore_conditions[i].checked) return true
						}
						return false;
					};

					$scope.onClickRestoreConfirm = function(backup) { $scope.backupHandler.restoreBackup(backup, function (){
						$scope.minimizeAll();
						$scope.checkStatus();
					})};

					$scope.onClickDownloadConfirm = function(backup) { $scope.backupHandler.generateBackup(backup, function() {
						$scope.minimizeAll();
						$scope.checkStatus();
					})};

					$scope.onClickDeleteDownloadConfirm = function(backup) { $scope.backupHandler.deleteDownload(backup, $scope.fetchData()); };

					$scope.downloadBackup = function (backup) { $scope.backupHandler.downloadBackup(backup); };

					$scope.$on("$destroy", function() {
						if($scope.interval !== null) {
							$scope.interval.clear();
							$interval.cancel($scope.interval);
							$scope.interval = null;
						}
					});

				}
			]
		);
	}
);