'use strict';

define([
		'app'
	], function (app) {
		app.controller('emailBackups',
			['$scope', '$interval', '$routeParams', 'meta', 'lang', 'backup', 'jetapi', 'consts', '$timeout',
				function ($scope, $interval, $routeParams, meta, lang, backup, jetapi, consts, $timeout) {

					$scope.backupType = consts.BACKUP_TYPE_EMAILS;

					$scope.backups = [];
					$scope.loading = false;
					$scope.actionModule= '';
					$scope.config = PAGE.config;
					$scope.refreshIntervalRate = 3000;
					$scope.interval = null;

					var metaEmailBackups = meta.new('emailBackups');
					$scope.meta = metaEmailBackups;
					$scope.metaData = metaEmailBackups.getData();

					metaEmailBackups.setSortReverse(false);
					if(!metaEmailBackups.getSortBy()) metaEmailBackups.setSortBy("name");
					if(!metaEmailBackups.getSortDirection()) metaEmailBackups.setSortDirection("asc");
					metaEmailBackups.setSortFields(["name", "created", "size", "location"]);
					metaEmailBackups.setTotalItems($scope.backups.length);

					$scope.backupHandler = new backup($scope.backupType, metaEmailBackups);

					$scope.fetchData = function() {
						$scope.loading = true;
						$scope.backups = [];
						$scope.backupHandler.loadList(function(response) {

							metaEmailBackups.setTotalItems(response.data.total);
							metaEmailBackups.calculate(response.data.backups);
							$scope.backups = response.data.backups;
							$scope.loading = false;

							$scope.backupHandler.checkStatus($scope);
							$scope.backupHandler.setList($scope.backups);
						});
					};

					$scope.checkStatus = function () {
						if(!$scope.backupHandler.hasQueueItem) return;
						$scope.interval = $interval(function() {
							if(!$scope.backupHandler.hasQueueItem()){
								$interval.cancel($scope.interval);
								$scope.interval = null;
								return;
							}
							$scope.backupHandler.checkStatus($scope);
						}, $scope.refreshIntervalRate);
					};

					$timeout(function () {
						$scope.fetchData();
						$scope.checkStatus();
					}());

					$scope.$on("$destroy", function() {
						if($scope.interval !== undefined) {
							$interval.cancel($scope.interval);
							$scope.interval = null;
						}
					});
				}
			]
		);
	}
);