define([
		"app"
	],function(app) {
		app.controller("settings",
			["$rootScope", "$scope", "$timeout", "jetapi",
				function($rootScope, $scope, $timeout, jetapi) {


					$scope.saveData = {};
					$scope.saveChangesStatus = false;


					$scope.clearStatus = function () { $scope.saveChangesStatus = null; };

					$scope.saveChanges = function() {

						$scope.savingChanges = true;
						$scope.saveChangesStatus = undefined;

						jetapi.manageAccount($scope.saveData, function(response) {
							$scope.savingChanges = false;

							$scope.saveChangesStatus = {
								message: response.status ? response.messages[0] : response.errors[0],
								type: response.status ? "success" : "danger",
								closeable: true,
								ttl: 10000
							};
						});
					};

					$scope.fetch = function () {
						jetapi.getAccountDetails({}, function(response) {

							$scope.settings = response.data;
							if(!response.status) {
								$scope.saveChangesStatus = {
									message: response.errors[0],
									type: 'danger',
									closeable: true,
									ttl: 10000
								};
							}
							$scope.saveData = response.data;
						});
					};
					$timeout($scope.fetch);
				}
			]
		);

	}
);