/*
* base/frontend/paper_lantern/jetbackup/services/jetapi.js
*
* JetBackup @ package
* Created By Idan Ben-Ezra
*
* Copyrights @ JetApps
* https://www.jetapps.com
*
**/
'use strict';

define(
	[
		"app"
	],
	function(app) {

	app.factory('jetapi', ["$q", "$http", "$httpParamSerializer", "lang", function ($q, $http, $httpParamSerializer, lang) {

		var _exec = function(cmd, apiParams, callback, params) {

			if (!apiParams) apiParams = {};

			var request = $http.post('../../../execute/JetBackup/' + cmd, apiParams, {
				transformRequest: $httpParamSerializer,
				headers: { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8' }
			});

			request.then(function(response) {
				if (response.data.messages && response.data.messages.length)
					for(var i=0; i<response.data.messages.length; i++) 
						response.data.messages[i] = lang.t('exceptions|:|' + response.data.messages[i]);

				if (response.data.errors && response.data.errors.length){
					for(var i=0; i<response.data.errors.length; i++) {
						var _data = [ 'exceptions|:|' + response.data.errors[i] ];
						if(response.data.data && typeof response.data.data == "object" && response.data.data.length > 0){
							for(var j=0; j<response.data.data.length; j++)
								_data.push(response.data.data[j]); 
						}
						response.data.errors[i] = lang.t.apply(lang, _data);
					}
				}

				if (response.data.warnings && response.data.warnings.length)
					for(var i=0; i<response.data.warnings.length; i++) 
						response.data.warnings[i] = lang.t('exceptions|:|' + response.data.warnings[i]);


				/*
				if(response.data.system.licenseIssue || response.data.system.agreement || response.data.system.drMode) {

					var location = '';
					window.PAGE.system = response.data.system;

					if(response.data.system.drMode) location = '/disasterRecovery';
					if(response.data.system.agreement) location = '/agreement';
					if(response.data.system.licenseIssue) location = '/license';

					$location.path(location);
				}
				*/

				if(callback !== undefined && typeof callback === 'function') callback(response.data, params);
			});

			return request;
		};

		return {
			getSettings: function (apiParams, callback, params) { return _exec('getSettings', apiParams, callback, params); },
			manageSettings: function (apiParams, callback, params) { return _exec('manageSettings', apiParams, callback, params); },
			getGDPR: function (apiParams, callback, params) { return _exec('getGDPR', apiParams, callback, params); },
			manageGDPR: function (apiParams, callback, params) { return _exec('manageGDPR', apiParams, callback, params); },
			getAccountDetails: function (apiParams, callback, params) { return _exec('getAccountDetails', apiParams, callback, params); },
			getAccount: function (apiParams, callback, params) { return _exec('getAccount', apiParams, callback, params); },
			manageAccount: function (apiParams, callback, params) { return _exec('manageAccount', apiParams, callback, params); },
			getBackup: function (apiParams, callback, params) { return _exec('getBackup', apiParams, callback, params); },
			listBackups: function (apiParams, callback, params) { return _exec('listBackups', apiParams, callback, params); },
			manageBackup: function (apiParams, callback, params) { return _exec('manageBackup', apiParams, callback, params); },
			addQueueRestore: function (apiParams, callback, params) { return _exec('addQueueRestore', apiParams, callback, params); },
			addQueueSnapshot: function (apiParams, callback, params) { return _exec('addQueueSnapshot', apiParams, callback, params); },
			calculateBackupSize: function (apiParams, callback, params) { return _exec('calculateBackupSize', apiParams, callback, params); },
			deleteDownload: function (apiParams, callback, params) { return _exec('deleteDownload', apiParams, callback, params); },
			getDownload: function (apiParams, callback, params) { return _exec('getDownload', apiParams, callback, params); },
			getBackupDownloads: function (apiParams, callback, params) { return _exec('getBackupDownloads', apiParams, callback, params); },
			addQueueDownload: function (apiParams, callback, params) { return _exec('addQueueDownload', apiParams, callback, params); },
			getQueueItem: function (apiParams, callback, params) { return _exec('getQueueItem', apiParams, callback, params); },
			listQueueItems: function (apiParams, callback, params) { return _exec('listQueueItems', apiParams, callback, params); },
			cancelQueueItem: function (apiParams, callback, params) { return _exec('cancelQueueItem', apiParams, callback, params); },
			fileManager: function (apiParams, callback, params) { return _exec('fileManager', apiParams, callback, params); },
			listRestoreConditions: function (apiParams, callback, params) { return _exec('listRestoreConditions', apiParams, callback, params); }
		};

	}]);
});