'use strict';

define(['app'], function (app) {
	app.factory('utils', function () {

		var UTILS = function() {};

		UTILS.prototype = {

			sizeToHumanReadable: function(bytes, si) {
				if(si === undefined) si = false;
				var unit = si ? 1000 : 1024;
				if (bytes < unit) return bytes + " B";
				var exp = parseInt(Math.log(bytes)/Math.log(unit));
				var pre = (si ? "kMGTPE" : "KMGTPE");
				pre = pre[exp-1];// + (si ? "" : "i");
				return (bytes/Math.pow(unit, exp)).toFixed(2) + " " + pre + "B";
			},
		};

		return new UTILS();


	});
});